## mingw-w64-qt6-base-6.10.0-2.src.tar.zst

=== examples/corelib/mimetypes/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

if(TARGET Qt6::Widgets)
    qt_internal_add_example(mimetypebrowser)
endif()

=== tests/auto/other/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(TARGET Qt::Widgets)
    add_subdirectory(gestures)
    add_subdirectory(languagechange)
    add_subdirectory(qfocusevent)
    add_subdirectory(qsharedpointer_and_qwidget)
    # add_subdirectory(windowsmobile) <- does not exist
endif()
if(TARGET Qt::Network AND TARGET Qt::Widgets)
    add_subdirectory(qnetworkaccessmanager_and_qprogressdialog)
endif()
if(MACOS AND TARGET Qt::Gui AND TARGET Qt::Widgets)
    add_subdirectory(macgui)
    add_subdirectory(macplist)
    add_subdirectory(qaccessibilitymac)
endif()
if(TARGET Qt::Network)
    add_subdirectory(networkselftest)
endif()
if(QT_FEATURE_accessibility AND TARGET Qt::Gui AND TARGET Qt::Widgets)
    add_subdirectory(qaccessibility)
endif()
if(TARGET Qt::Gui)
    add_subdirectory(qcomplextext)
endif()
add_subdirectory(qobjectrace)
add_subdirectory(toolsupport)
# QTBUG-87670
if(QT_FEATURE_process AND TARGET Qt::Gui AND NOT ANDROID)
    add_subdirectory(qprocess_and_guieventloop)
endif()
if(QT_FEATURE_accessibility_atspi_bridge AND TARGET Qt::Gui AND TARGET Qt::Widgets)
    #add_subdirectory(qaccessibilitylinux) # TODO: This test is broken
endif()
if(MACOS AND TARGET Qt::Gui)
    # add_subdirectory(macnativeevents) # TODO: it's disabled in qmake too
endif()
if(embedded)
    add_subdirectory(qdirectpainter)
endif()
if(QT_FEATURE_xkbcommon AND TARGET Qt::Gui)
    add_subdirectory(xkbkeyboard)
endif()

if(ANDROID AND QT_BUILD_STANDALONE_TESTS)
    add_subdirectory(android)
endif()

=== examples/widgets/tutorials/notepad/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: LicenseRef-Qt-Commercial OR BSD-3-Clause

cmake_minimum_required(VERSION 3.16)
project(notepad LANGUAGES CXX)

find_package(Qt6
    REQUIRED COMPONENTS Core Gui Widgets
    OPTIONAL_COMPONENTS PrintSupport
)

qt_standard_project_setup()

qt_add_executable(notepad
    main.cpp
    notepad.cpp notepad.h notepad.ui
)

set_target_properties(notepad PROPERTIES
    WIN32_EXECUTABLE TRUE
    MACOSX_BUNDLE TRUE
)

target_link_libraries(notepad PRIVATE
    Qt6::Core
    Qt6::Gui
    Qt6::Widgets
)

if(TARGET Qt6::PrintSupport)
    target_link_libraries(notepad PRIVATE Qt6::PrintSupport)
endif()

# Resources:
set(notepad_resource_files
    "images/bold.png"
    "images/copy.png"
    "images/create.png"
    "images/cut.png"
    "images/edit_redo.png"
    "images/edit_undo.png"
    "images/exit.png"
    "images/font.png"
    "images/info.png"
    "images/italic.png"
    "images/new.png"
    "images/open.png"
    "images/paste.png"
    "images/pencil.png"
    "images/print.png"
    "images/save.png"
    "images/save_as.png"
    "images/underline.png"
)

qt_add_resources(notepad "notepad"
    PREFIX
        "/"
    FILES
        ${notepad_resource_files}
)

install(TARGETS notepad
    BUNDLE  DESTINATION .
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

qt_generate_deploy_app_script(
    TARGET notepad
    OUTPUT_SCRIPT deploy_script
    NO_UNSUPPORTED_PLATFORM_ERROR
)
install(SCRIPT ${deploy_script})

=== src/plugins/networkinformation/networkmanager/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_internal_add_plugin(QNetworkManagerNetworkInformationPlugin
    OUTPUT_NAME qnetworkmanager
    CLASS_NAME QNetworkManagerNetworkInformationBackendFactory
    PLUGIN_TYPE networkinformation
    DEFAULT_IF LINUX
    SOURCES
        qnetworkmanagernetworkinformationbackend.h
        qnetworkmanagernetworkinformationbackend.cpp
        qnetworkmanagerservice.h
        qnetworkmanagerservice.cpp
    LIBRARIES
        Qt::DBus
        Qt::NetworkPrivate
)

=== src/plugins/platforms/ios/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## QIOSIntegrationPlugin Plugin:
#####################################################################

if(VISIONOS)
    include(SwiftIntegration.cmake)

    qt_install(TARGETS QIOSIntegrationPluginSwift
        EXPORT "${INSTALL_CMAKE_NAMESPACE}QIOSIntegrationPluginTargets"
        DESTINATION "${INSTALL_LIBDIR}"
    )
    qt_internal_add_targets_to_additional_targets_export_file(
        TARGETS QIOSIntegrationPluginSwift
        EXPORT_NAME_PREFIX "${INSTALL_CMAKE_NAMESPACE}QIOSIntegrationPlugin"
    )
endif()

qt_internal_add_plugin(QIOSIntegrationPlugin
    OUTPUT_NAME qios
    STATIC # Force static, even in shared builds
    DEFAULT_IF "ios" IN_LIST QT_QPA_PLATFORMS
    PLUGIN_TYPE platforms
    SOURCES
        plugin.mm
        qiosapplicationdelegate.h qiosapplicationdelegate.mm
        qiosapplicationstate.h qiosapplicationstate.mm
        qioseventdispatcher.h qioseventdispatcher.mm
        qiosglobal.h qiosglobal.mm
        qiosinputcontext.h qiosinputcontext.mm
        qiosintegration.h qiosintegration.mm
        qiosplatformaccessibility.h qiosplatformaccessibility.mm
        qiosscreen.h qiosscreen.mm
        qiosservices.h qiosservices.mm
        qiostextresponder.h qiostextresponder.mm
        qiostheme.h qiostheme.mm
        qiosviewcontroller.h qiosviewcontroller.mm
        qioswindow.h qioswindow.mm
        quiaccessibilityelement.h quiaccessibilityelement.mm
        quiview.h quiview.mm
        quiwindow.mm quiwindow.h
        uistrings_p.h uistrings.cpp
    NO_PCH_SOURCES
        qioscontext.mm # undef QT_NO_FOREACH
        qiosintegration.mm # undef QT_NO_FOREACH
        qiosplatformaccessibility.mm # undef QT_NO_FOREACH
        qiosscreen.mm # undef QT_NO_FOREACH
    LIBRARIES
        ${FWAudioToolbox}
        ${FWFoundation}
        ${FWMetal}
        ${FWQuartzCore}
        ${FWUIKit}
        ${FWCoreGraphics}
        Qt::CorePrivate
        Qt::GuiPrivate
)

qt_disable_apple_app_extension_api_only(QIOSIntegrationPlugin)

## Scopes:
#####################################################################
qt_internal_find_apple_system_framework(FWUniformTypeIdentifiers UniformTypeIdentifiers)

qt_internal_extend_target(QIOSIntegrationPlugin CONDITION QT_FEATURE_opengl
    SOURCES
        qioscontext.h qioscontext.mm
    LIBRARIES
        Qt::OpenGLPrivate
)

qt_internal_extend_target(QIOSIntegrationPlugin CONDITION QT_FEATURE_clipboard
    SOURCES
        qiosclipboard.h qiosclipboard.mm
)

qt_internal_extend_target(QIOSIntegrationPlugin CONDITION NOT TVOS
    SOURCES
        qiosfiledialog.h qiosfiledialog.mm
        qiosdocumentpickercontroller.h qiosdocumentpickercontroller.mm
    LIBRARIES
        ${FWUniformTypeIdentifiers}
        ${FWPhotos}
)

qt_internal_extend_target(QIOSIntegrationPlugin CONDITION NOT TVOS
    SOURCES
        qioscolordialog.h qioscolordialog.mm
        qiosfontdialog.h qiosfontdialog.mm
        qiosmessagedialog.h qiosmessagedialog.mm
)

qt_internal_extend_target(QIOSIntegrationPlugin CONDITION NOT (TVOS OR VISIONOS)
    SOURCES
        qiosmenu.h qiosmenu.mm
        qiostextinputoverlay.h qiostextinputoverlay.mm
)

add_subdirectory(optional)

if(VISIONOS)
    target_link_libraries(QIOSIntegrationPlugin PRIVATE QIOSIntegrationPluginSwift)
endif()

=== src/plugins/sqldrivers/mysql/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## QMYSQLDriverPlugin Plugin:
#####################################################################

qt_internal_add_plugin(QMYSQLDriverPlugin
    OUTPUT_NAME qsqlmysql
    PLUGIN_TYPE sqldrivers
    SOURCES
        main.cpp
        qsql_mysql.cpp qsql_mysql_p.h
    DEFINES
        QT_NO_CAST_FROM_ASCII
        QT_NO_CAST_TO_ASCII
        QT_NO_CONTEXTLESS_CONNECT
    LIBRARIES
        MySQL::MySQL
        Qt::Core
        Qt::CorePrivate
        Qt::SqlPrivate
)

qt_internal_force_macos_intel_arch(QMYSQLDriverPlugin)

=== tests/auto/cmake/test_QTP0003/CMakeLists.txt ===
# Copyright (C) 2024 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.16)

project(test_QTP0003)

find_package(Qt6 COMPONENTS Core REQUIRED)

if(QT6_IS_SHARED_LIBS_BUILD)
    set(qt_build_type "SHARED_LIBRARY")
else()
    set(qt_build_type "STATIC_LIBRARY")
endif()

set(BUILD_SHARED_LIBS ON)
qt6_add_library(MyLib source.cpp)
get_target_property(type MyLib TYPE)
if(NOT "${type}" STREQUAL "${qt_build_type}")
    message(FATAL_ERROR "The library uses the default type different from Qt build type when"
        "QTP0003 is not set")
endif()

set(BUILD_SHARED_LIBS OFF)
qt6_add_library(MyLib2 source.cpp)
get_target_property(type MyLib2 TYPE)
if(NOT "${type}" STREQUAL "${qt_build_type}")
    message(FATAL_ERROR "The library uses the default type different from Qt build type when"
        "QTP0003 is not set")
endif()

set(BUILD_SHARED_LIBS ON)
qt_policy(SET QTP0003 OLD)
qt6_add_library(MyLib3 source.cpp)
get_target_property(type MyLib3 TYPE)
if(NOT "${type}" STREQUAL "${qt_build_type}")
    message(FATAL_ERROR "The library uses the default type different from Qt build type when"
        "QTP0003 is set to OLD")
endif()

set(BUILD_SHARED_LIBS OFF)
qt_policy(SET QTP0003 OLD)
qt6_add_library(MyLib4 source.cpp)
get_target_property(type MyLib4 TYPE)
if(NOT "${type}" STREQUAL "${qt_build_type}")
    message(FATAL_ERROR "The library uses the default type different from Qt build type when"
        "QTP0003 is set to OLD")
endif()

set(BUILD_SHARED_LIBS ON)
qt_policy(SET QTP0003 NEW)
qt6_add_library(MyLib5 source.cpp)
get_target_property(type MyLib5 TYPE)
if(NOT "${type}" STREQUAL "SHARED_LIBRARY")
    message(FATAL_ERROR "The library doesn't consider the BUILD_SHARED_LIBS when"
        "QTP0003 is set to NEW")
endif()

set(BUILD_SHARED_LIBS OFF)
qt_policy(SET QTP0003 NEW)
qt6_add_library(MyLib6 source.cpp)
get_target_property(type MyLib6 TYPE)
if(NOT "${type}" STREQUAL "STATIC_LIBRARY")
    message(FATAL_ERROR "The library doesn't consider the BUILD_SHARED_LIBS when"
        "QTP0003 is set to NEW")
endif()

=== tests/auto/cmake/test_android_multi_abi_forward_vars/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.16)

project(test_android_multi_abi_forward_vars)

find_package(Qt6 COMPONENTS Core Gui REQUIRED)

if(NOT TEST_SINGLE_VALUE_ARG STREQUAL "TestValue")
    message(FATAL_ERROR
        "TEST_SINGLE_VALUE_ARG is not valid: ${TEST_SINGLE_VALUE_ARG}")
endif()

if(NOT TEST_LIST_VALUE_ARG STREQUAL "TestValue;TestValue2;TestValue3")
    message(FATAL_ERROR
        "TEST_LIST_VALUE_ARG is not valid: ${TEST_LIST_VALUE_ARG}")
endif()

if(NOT TEST_ESCAPING_VALUE_ARG STREQUAL "TestValue\;TestValue2\;TestValue3")
    message(FATAL_ERROR
        "TEST_ESCAPING_VALUE_ARG is not valid: ${TEST_ESCAPING_VALUE_ARG}")
endif()

if(NOT TEST_SPACES_VALUE_ARG STREQUAL "TestValue TestValue2 TestValue3")
    message(FATAL_ERROR
        "TEST_SPACES_VALUE_ARG is not valid: ${TEST_SPACES_VALUE_ARG}")
endif()

# Make sure that ABI external projects are created
qt6_add_executable(test_executable main.cpp)

target_link_libraries(test_executable PRIVATE Qt::Core Qt::Gui)

=== tests/auto/cmake/test_qt_manual_moc/CMakeLists.txt ===
# Copyright (C) 2024 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

cmake_minimum_required(VERSION 3.16)

find_package(Qt6 ${PROJECT_VERSION} CONFIG REQUIRED COMPONENTS BuildInternals Core)

set(CMAKE_AUTOMOC FALSE)

qt_manual_moc(moc_files testclass.h
    DEFINITIONS
        -DMY_FIRST_DEF
        MY_SECOND_DEF
        -DMY_THIRD_DEF=1
        MY_FOURTH_DEF=1
)

add_custom_target(verify_testclass ALL COMMAND ${CMAKE_COMMAND}
    "-DMOC_ARGS=moc_testclass.cpp_parameters$<$<BOOL:$<CONFIG>>:_$<CONFIG>>"
    "-DDEFINITIONS=MY_FIRST_DEF;MY_SECOND_DEF;MY_THIRD_DEF=1;MY_FOURTH_DEF=1"
    -P "${CMAKE_CURRENT_SOURCE_DIR}/VerifyDefines.cmake"
    VERBATIM
)

add_library(MyInterfaceLib INTERFACE)
target_compile_definitions(MyInterfaceLib INTERFACE -DMY_TRANSITIVE_DEF=1)

add_library(MyLib SHARED testclass1.h testclass.cpp)
target_link_libraries(MyLib PRIVATE Qt6::Core MyInterfaceLib)
target_compile_definitions(MyLib PRIVATE
    -DMY_FIRST_DEF
    MY_SECOND_DEF
    -DMY_THIRD_DEF=1
    MY_FOURTH_DEF=1
)

add_library(MyLib2 SHARED testclass1.h testclass.cpp)
target_link_libraries(MyLib2 PRIVATE Qt6::Core)
target_compile_definitions(MyLib2 PRIVATE
    -DMY_FOREIGN_DEF
)

qt_manual_moc(moc_files testclass1.h TARGETS MyLib MyLib2)
target_sources(MyLib PRIVATE ${moc_files})
target_sources(MyLib2 PRIVATE ${moc_files})

string(JOIN ";" expected
    "MY_FIRST_DEF"
    "MY_SECOND_DEF"
    "MY_THIRD_DEF=1"
    "MY_FOURTH_DEF=1"
    "MY_TRANSITIVE_DEF=1"
    "MY_FOREIGN_DEF"
)

add_custom_target(verify_testclass1 ALL COMMAND ${CMAKE_COMMAND}
    "-DMOC_ARGS=moc_testclass1.cpp_parameters$<$<BOOL:$<CONFIG>>:_$<CONFIG>>"
    "-DDEFINITIONS=${expected}"
    -P "${CMAKE_CURRENT_SOURCE_DIR}/VerifyDefines.cmake"
    VERBATIM
)

=== tests/auto/concurrent/qtconcurrentiteratekernel/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## tst_qtconcurrentiteratekernel Test:
#####################################################################

if(NOT QT_BUILD_STANDALONE_TESTS AND NOT QT_BUILDING_QT)
    cmake_minimum_required(VERSION 3.16)
    project(tst_qtconcurrentiteratekernel LANGUAGES CXX)
    find_package(Qt6BuildInternals REQUIRED COMPONENTS STANDALONE_TEST)
endif()

qt_internal_add_test(tst_qtconcurrentiteratekernel
    SOURCES
        tst_qtconcurrentiteratekernel.cpp
    LIBRARIES
        Qt::Concurrent
)

=== tests/auto/corelib/io/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# There is no mounted filesystem for IO testing on INTEGRITY yet.
if(INTEGRITY)
    return()
endif()

if(QT_FEATURE_private_tests)
    add_subdirectory(qabstractfileengine)
    add_subdirectory(qfileinfo)
    add_subdirectory(qipaddress)
    add_subdirectory(qloggingregistry)
    add_subdirectory(qurlinternal)
endif()
add_subdirectory(qbuffer)
add_subdirectory(qdataurl)
add_subdirectory(qdiriterator)
add_subdirectory(qdirlisting)
add_subdirectory(qfile)
add_subdirectory(largefile)
add_subdirectory(qfileselector)
add_subdirectory(qfilesystemmetadata)
add_subdirectory(qloggingcategory)
add_subdirectory(qnodebug)
add_subdirectory(qsavefile)
add_subdirectory(qstandardpaths)
if(NOT QNX AND NOT VXWORKS)
    add_subdirectory(qstorageinfo)
endif()
add_subdirectory(qtemporarydir)
add_subdirectory(qtemporaryfile)
add_subdirectory(qurlquery)
add_subdirectory(qurluts46)
if(TARGET Qt::Concurrent)
    if(NOT INTEGRITY)
        add_subdirectory(qdebug)
    endif()
    add_subdirectory(qlockfile)
    add_subdirectory(qurl)
endif()
if(NOT ANDROID)
    add_subdirectory(qdir)
    add_subdirectory(qresourceengine)
endif()
if(QT_FEATURE_private_tests)
    add_subdirectory(qfilesystementry)
endif()
# QTBUG-88508
if(QT_FEATURE_filesystemwatcher AND NOT ANDROID)
    add_subdirectory(qfilesystemwatcher)
endif()
if(TARGET Qt::Network)
    add_subdirectory(qiodevice)
endif()
if(QT_FEATURE_process AND TARGET Qt::Network AND NOT ANDROID)
    add_subdirectory(qprocess)
endif()
if(QT_FEATURE_process)
    add_subdirectory(qprocess-noapplication)
endif()
if(QT_FEATURE_processenvironment)
    add_subdirectory(qprocessenvironment)
endif()
if(QT_FEATURE_settings AND TARGET Qt::Gui)
    add_subdirectory(qsettings)
endif()
if(QT_FEATURE_private_tests)
    add_subdirectory(qzip)
endif()

=== tests/auto/corelib/mimetypes/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

if(QT_FEATURE_private_tests)
    add_subdirectory(qmimetype)
endif()
add_subdirectory(qmimedatabase)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qt6-base
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-debug")
_qtver=6.10.0
pkgver=${_qtver/-/}
pkgrel=2
pkgdesc="A cross-platform application and UI framework (mingw-w64)"
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io'
msys2_repository_url="https://code.qt.io/cgit/qt/qtbase.git"
msys2_references=(
  'archlinux: qt6-base'
  "cpe: cpe:/a:qt:qt"
)
license=('spdx:LGPL-3.0-only WITH Qt-GPL-exception-1.0 AND AFL-2.1 AND Apache-2.0 AND BSL-1.0 AND CC0-1.0 AND BSD-3-Clause AND CC-BY-4.0 AND GFDL-1.3-no-invariants-only AND GPL-2.0-only AND GPL-2.0-or-later AND GPL-3.0-only AND custom')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-pkgconf"
             #"${MINGW_PACKAGE_PREFIX}-cppwinrt" breaks building qt6-multimedia ffmpeg plugin
             # qtmultimedia-everywhere-src-6.10.0/src/plugins/multimedia/ffmpeg/qffmpegwindowcapture_uwp.cpp:35:10: fatal error: 'windows.graphics.directx.direct3d11.interop.h' file not found
             # 35 | #include <windows.graphics.directx.direct3d11.interop.h>
             #    |          ^~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
             # 1 error generated.
             "${MINGW_PACKAGE_PREFIX}-dbus"
             "${MINGW_PACKAGE_PREFIX}-double-conversion"
             "${MINGW_PACKAGE_PREFIX}-freetype"
             "${MINGW_PACKAGE_PREFIX}-glib2"
             "${MINGW_PACKAGE_PREFIX}-harfbuzz"
             "${MINGW_PACKAGE_PREFIX}-icu"
             "${MINGW_PACKAGE_PREFIX}-libb2"
             "${MINGW_PACKAGE_PREFIX}-libjpeg-turbo"
             "${MINGW_PACKAGE_PREFIX}-libpng"
             "${MINGW_PACKAGE_PREFIX}-md4c"
             "${MINGW_PACKAGE_PREFIX}-openssl"
             "${MINGW_PACKAGE_PREFIX}-pcre2"
             "${MINGW_PACKAGE_PREFIX}-sqlite3"
             "${MINGW_PACKAGE_PREFIX}-zlib"
             "${MINGW_PACKAGE_PREFIX}-zstd"
             "${MINGW_PACKAGE_PREFIX}-xmlstarlet"
             "${MINGW_PACKAGE_PREFIX}-vulkan-loader"
             "${MINGW_PACKAGE_PREFIX}-vulkan-headers"
             "${MINGW_PACKAGE_PREFIX}-firebird"
             "${MINGW_PACKAGE_PREFIX}-libmariadbclient"
             "${MINGW_PACKAGE_PREFIX}-postgresql"
             "rsync")
_pkgfn="${_realname/6-/}-everywhere-src-${_qtver}"
source=("https://download.qt.io/official_releases/qt/${pkgver%.*}/${_qtver}/submodules/${_pkgfn}.tar.xz"
        001-appending-qt6-to-remove-qt5-conflict.patch
        002-fix-qtdocs-helpers-cmake.patch
        003-adjust-qmake-conf-mingw.patch
        004-qt-6.2.0-win32-g-Add-QMAKE_EXTENSION_IMPORTLIB-defaulting-to-.patch
        005-qt-6.7.0-opengl-header.patch
        006-qt-6.2.0-dont-add-resource-files-to-qmake-libs.patch
        008-freetype-fonts-fallback-dir.patch
        009-qfileinfo-undefine-mingw-stat.patch
        010-export-some-constexpr-variables.patch
        011-qt6-windeployqt-fixes.patch)
sha256sums=('ead4623bcb54a32257c5b3e3a5aec6d16ec96f4cda58d2e003f5a0c16f72046d'
            'c9f61d90ba7bce89f935c3e8ea90c448a641fd206666ef2d1542f61a3a655fc9'
            '0dac4b7c07ed52367f55cb54df5aee6966601edc579861e2504701f04c509b9b'
            '68156b8b7717a0ce19c4b991942469171bfa048cd5c90765115a546e65669a1d'
            'ed5b61bcb367bbda459bec903d796ea45604278f577a988d602ade07ec6bf363'
            'a2afc74d181864409dc96eca368b647c0f79e25751db88e3263f2d1101edf8e4'
            '4085a10b290b8e3d930de535cbad2ba3e643432cba433aa2b28fe664f86d38a3'
            'e2fbd970a20773f0d914f6ffc96aafc8212192227577ec007a460e35398038bf'
            'f4261d43a142a24e5fa3b23e25813754839db84078cc8c6dc611139bf531e64a'
            '23656a7839d7dcb763d022722d723493c847914b0639bab861ddb05d823af5b7'
            '1d605fa3c9a9820ddc2858db84376bca0cf24f91a4c1ae92d0cdea618506c60b')

# Use the right mkspecs file
if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
  _platform=win32-clang-g++
else
  _platform=win32-g++
fi

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd $srcdir/${_pkgfn}

  apply_patch_with_msg \
    001-appending-qt6-to-remove-qt5-conflict.patch \
    002-fix-qtdocs-helpers-cmake.patch \
    003-adjust-qmake-conf-mingw.patch \
    004-qt-6.2.0-win32-g-Add-QMAKE_EXTENSION_IMPORTLIB-defaulting-to-.patch \
    005-qt-6.7.0-opengl-header.patch \
    006-qt-6.2.0-dont-add-resource-files-to-qmake-libs.patch \
    008-freetype-fonts-fallback-dir.patch \
    009-qfileinfo-undefine-mingw-stat.patch \
    011-qt6-windeployqt-fixes.patch

  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    apply_patch_with_msg \
      010-export-some-constexpr-variables.patch
  fi

  local _ARCH_TUNE=
  if [[ ${CARCH} == x86_64 ]]; then
    _ARCH_TUNE="-march=nocona -msahf -mtune=generic"
  fi

  BIGOBJ_FLAGS="-Wa,-mbig-obj"

  # Append these ones ..
  sed -i "s|^QMAKE_CFLAGS .*= \(.*\)$|QMAKE_CFLAGS            = \1 ${_ARCH_TUNE} ${BIGOBJ_FLAGS}|g" mkspecs/${_platform}/qmake.conf
  sed -i "s|^QMAKE_CXXFLAGS .*= \(.*\)$|QMAKE_CXXFLAGS            = \1 ${_ARCH_TUNE} ${BIGOBJ_FLAGS}|g" mkspecs/${_platform}/qmake.conf
}

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  if [[ ${CC} == clang ]]; then
    CXXFLAGS+=" -Wno-character-conversion"
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    --log-level=STATUS \
    -GNinja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DQT_QMAKE_TARGET_MKSPEC=${_platform} \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DINSTALL_INCLUDEDIR=include/qt6 \
    -DINSTALL_ARCHDATADIR=share/qt6 \
    -DINSTALL_DATADIR=share/qt6 \
    -DINSTALL_MKSPECSDIR=share/qt6/mkspecs \
    -DINSTALL_DESCRIPTIONSDIR=share/qt6/modules \
    -DFEATURE_system_doubleconversion=ON \
    -DFEATURE_system_freetype=ON \
    -DFEATURE_system_jpeg=ON \
    -DFEATURE_system_harfbuzz=ON \
    -DFEATURE_system_pcre2=ON \
    -DFEATURE_system_png=ON \
    -DFEATURE_system_sqlite=ON \
    -DFEATURE_system_zlib=ON \
    -DFEATURE_zstd=ON \
    -DFEATURE_openssl=ON \
    -DFEATURE_opengl=ON \
    -DFEATURE_opengl_desktop=ON \
    -DFEATURE_dbus=ON \
    -DFEATURE_glib=ON \
    -DFEATURE_icu=ON \
    -DFEATURE_pkg_config=ON \
    -DFEATURE_vulkan=ON \
    -DFEATURE_sql_sqlite=ON \
    -DFEATURE_sql_psql=ON \
    -DFEATURE_sql_mysql=ON \
    -DFEATURE_sql_odbc=ON \
    -DFEATURE_sql_ibase=ON \
    -DFEATURE_gtk3=OFF \
    -DFEATURE_regularexpression=ON \
    -DFEATURE_cxx20=ON \
    -DFEATURE_cpp_winrt=OFF \
    -DFEATURE_force_debug_info=ON \
    -DFEATURE_separate_debug_info=ON \
    ../${_pkgfn}

  PATH=$PWD/bin:$PATH ${MINGW_PREFIX}/bin/cmake --build .
}

package_qt6-base() {
  depends=("${MINGW_PACKAGE_PREFIX}-double-conversion"
           "${MINGW_PACKAGE_PREFIX}-dbus"
           "${MINGW_PACKAGE_PREFIX}-freetype"
           "${MINGW_PACKAGE_PREFIX}-glib2"
           "${MINGW_PACKAGE_PREFIX}-harfbuzz"
           "${MINGW_PACKAGE_PREFIX}-icu"
           "${MINGW_PACKAGE_PREFIX}-libb2"
           "${MINGW_PACKAGE_PREFIX}-libjpeg-turbo"
           "${MINGW_PACKAGE_PREFIX}-libpng"
           "${MINGW_PACKAGE_PREFIX}-md4c"
           "${MINGW_PACKAGE_PREFIX}-openssl"
           "${MINGW_PACKAGE_PREFIX}-pcre2"
           "${MINGW_PACKAGE_PREFIX}-sqlite3"
           "${MINGW_PACKAGE_PREFIX}-vulkan-loader"
           "${MINGW_PACKAGE_PREFIX}-vulkan-headers"
           "${MINGW_PACKAGE_PREFIX}-zlib"
           "${MINGW_PACKAGE_PREFIX}-zstd")
  optdepends=("${MINGW_PACKAGE_PREFIX}-libmariadbclient: MySQL/MariaDB driver"
              "${MINGW_PACKAGE_PREFIX}-postgresql: PostgreSQL driver"
              "${MINGW_PACKAGE_PREFIX}-firebird: Firebird/iBase driver")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6")

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  install -d "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 $_pkgfn/LICENSES/* -t "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}

  # Seperate debug-info files
  rsync -armR --remove-source-files --include="*/" --include="*.debug" --exclude="*" --prune-empty-dirs "${pkgdir}"/.${MINGW_PREFIX} "${srcdir}"/${MSYSTEM}-debug/

  # Restore qmake6, qtpaths6 and windeployqt6
  ln -s "${pkgdir}"${MINGW_PREFIX}/bin/qmake-qt6 "${pkgdir}"${MINGW_PREFIX}/bin/qmake6.exe
  ln -s "${pkgdir}"${MINGW_PREFIX}/bin/qtpaths-qt6 "${pkgdir}"${MINGW_PREFIX}/bin/qtpaths6.exe
  ln -s "${pkgdir}"${MINGW_PREFIX}/bin/windeployqt-qt6 "${pkgdir}"${MINGW_PREFIX}/bin/windeployqt6.exe

  # Fix *.pri, *.bat and *.cmake files
  local PREFIX_WIN=$(cygpath -m ${MINGW_PREFIX})
  find "${pkgdir}${MINGW_PREFIX}/share/qt6" -type f \( -name '*.pri' -o -name '*.bat' \) \
      -exec sed -i -e "s|${PREFIX_WIN}|${MINGW_PREFIX}|g" {} \;
  find "${pkgdir}${MINGW_PREFIX}/bin" -type f \( -name '*.bat' \) \
      -exec sed -i -e "s|${PREFIX_WIN}|${MINGW_PREFIX}|g" {} \;
  find "${pkgdir}${MINGW_PREFIX}/lib/cmake" -type f \( -name '*.cmake' \) \
      -exec sed -i -e "s|${PREFIX_WIN}|${MINGW_PREFIX}|g" {} \;
}

package_qt6-base-debug() {
  depends=("${MINGW_PACKAGE_PREFIX}-${_realname}")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6-debug")
  options=('!strip')

  cp -rf "${srcdir}"/${MSYSTEM}-debug${MINGW_PREFIX} "${pkgdir}"/
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
